/*****************
 **** User Js ****
 *****************/

$('head').append('<link href="res/auth/okta-signin-widget-5.0.1/css/okta-sign-in.min.css" type="text/css" rel="stylesheet"/>');
$('body').append('<div id="okta_frame" class="container"> <div id="messageBox" style="position:relative" class="jumbotron"> <div id="sign-in-container"></div> </div> </div>'); 

Services.callSync("getConfig");

//Storage.clear();   -- TODO You cannot do it here! Okta relies on storage!
Storage.set("AP_TICKET", "");
Storage.set("_is_logged_in", false);

var oktaSignIn = new OktaSignIn({
    baseUrl:        "https://dish.okta.com",
    clientId:       Storage.get("OKTA_CLIENT"),
    redirectUri:    Storage.get("OKTA_REDIRECT_URL"),
    authParams: {
        pkce: false,
        issuer:         "https://dish.okta.com",
        responseType:   ["token", "id_token"],
        display:        "page"
    }
});

oktaSignIn.authClient.session.get().then(function(res) {
    if (res.status === 'ACTIVE') {
        onActiveSession(res);
        return;
    }

    oktaSignIn.renderEl({
        el: '#sign-in-container'
    },
    onTokensReceived,
    function error(err) {
        console.error(err);
    });
});

function onTokensReceived(res) {
    var accessToken = res.tokens.accessToken;
    var idToken = res.tokens.idToken;
    
    oktaSignIn.authClient.tokenManager.add('accessToken', accessToken);
    oktaSignIn.authClient.tokenManager.add('idToken', idToken);
    
    sessionStorage.setItem('okta_login', idToken.claims.email);
	sessionStorage.setItem("_is_logged_in", true);
	var OktaUser = $("#okta-signin-username").val();
	if (OktaUser){
	    Storage.set("OktaUser", OktaUser );
	}
	
	document.getElementById("messageBox").innerHTML = "Hello, " + idToken.claims.email + "!<br/>You are logged in! :)";
	
	Services.setHeader('Authorization', 'Bearer ' + idToken.idToken);
	Storage.set('id_token', idToken.idToken);
    Storage.get("AP_REFERRER", "oktaLogin");
    oktaSignIn.remove();
    $('#okta_frame').remove();
	Page.navigate('Home.html');
}

function onActiveSession() {
    oktaSignIn.authClient.token.getWithoutPrompt({
        scopes: ['openid', 'email', 'profile'],
    }).then(onTokensReceived)
    .catch(function(error) {
        console.error(error)
    });
}

/*************************
 *** Auto generated Js ***
 *************************/
	$('#header-title').hide();
		$("#mainPage").removeClass("centred");

	$('#titleRow-button').css("visibility", "hidden");

	defaultValues = {};
	

	$(document).ready(function(){
		Spinner.init();
		Page.validateLogin();
	    
	    
	    
	    document.forms[0].onsubmit = function() {return false};
		
		validateHeaderTitle();
		Fields.initEvents();
		Fields.setDefaultValues();
		Init.initData();
	});
	
	function validateHeaderTitle() {
			if (document.URL.indexOf("theme_editor") == -1) {
				$('#header-title').text('Login');
				$('#app-header-title').text('');
			}
		
		
		$('#header-title').show();
	}
	
	function sendRequestHandler() {
		$("#tableOutput").hide();
		$("#listOutput").hide();
	}
	
	function receiveResponseHandler(response, serviceName, status, populateFields) {
	    if (typeof(populateFields) === 'undefined' || populateFields) {
	    	$("#tableOutput").show();
	    	$("#listOutput").show();
	    }
	}